#pragma once

#include <stdint.h>

namespace drivers {
namespace opensbi {

    typedef unsigned long sbiword_t;
    typedef const unsigned long * hart_mask_t;

    struct HartMask {
        unsigned long mask;
        unsigned long base;
    };

    struct SbiRet {
        sbiword_t error;
        sbiword_t value;
    };

    SbiRet ecall(
            sbiword_t extension,
            sbiword_t function,
            sbiword_t a0,
            sbiword_t a1,
            sbiword_t a2,
            sbiword_t a3,
            sbiword_t a4,
            sbiword_t a5);

    SbiRet ecall(
            sbiword_t extension,
            sbiword_t function,
            sbiword_t a0,
            sbiword_t a1,
            sbiword_t a2,
            sbiword_t a3,
            sbiword_t a4);

    SbiRet ecall(
            sbiword_t extension,
            sbiword_t function,
            sbiword_t a0,
            sbiword_t a1,
            sbiword_t a2,
            sbiword_t a3);

    SbiRet ecall(
            sbiword_t extension,
            sbiword_t function,
            sbiword_t a0,
            sbiword_t a1,
            sbiword_t a2);

    SbiRet ecall(
            sbiword_t extension,
            sbiword_t function,
            sbiword_t a0,
            sbiword_t a1);

    SbiRet ecall(
            sbiword_t extension,
            sbiword_t function,
            sbiword_t a0);

    SbiRet ecall(
            sbiword_t extension,
            sbiword_t function);

}  // End namespace opensbi
}  // End namespace drivers
